import 'dart:async';
import 'package:yuro_core/yuro_core.dart';

extension EventBusExt on YuroInterface {
  static StreamController _streamController = StreamController.broadcast();

  Stream<T> on<T>() {
    if (T == dynamic) {
      return _streamController.stream;
    } else {
      return _streamController.stream.where((event) => event is T).cast<T>();
    }
  }

  void send(event) => _streamController.add(event);
}
